Attribute VB_Name = "APISupport"
Option Explicit

  'subclassing variables
  Public PrevLEWndProc As Long
  Public PrevTbarWndProc As Long
  Public PrevPropWndProc As Long
  
  'savefile configuration
  Public ofn As OPENFILENAME
  
  'start directory for directory browser
  Public BrowserStartDir As String
  
  Public Const WM_USER = &H400
  'edit box messages
  Public Const EM_GETSEL = &HB0
  Public Const EM_SETSEL = &HB1
  Public Const EM_GETRECT = &HB2
  Public Const EM_SETRECT = &HB3
  Public Const EM_SETRECTNP = &HB4
  Public Const EM_SCROLL = &HB5
  Public Const EM_LINESCROLL = &HB6
  Public Const EM_SCROLLCARET = &HB7
  Public Const EM_GETMODIFY = &HB8
  Public Const EM_SETMODIFY = &HB9
  Public Const EM_GETLINECOUNT = &HBA
  Public Const EM_LINEINDEX = &HBB
  Public Const EM_SETHANDLE = &HBC
  Public Const EM_GETHANDLE = &HBD
  Public Const EM_GETTHUMB = &HBE
  Public Const EM_LINELENGTH = &HC1
  Public Const EM_REPLACESEL = &HC2
  Public Const EM_GETLINE = &HC4
  Public Const EM_LIMITTEXT = &HC5
  Public Const EM_CANUNDO = &HC6
  Public Const EM_UNDO = &HC7
  Public Const EM_REDO = &H400& + 84&
  Public Const EM_CANREDO = &H400& + 85&
  Public Const EM_FORMATRANGE = WM_USER + 57
  Public Const EM_FMTLINES = &HC8
  Public Const EM_LINEFROMCHAR = &HC9
  Public Const EM_SETTABSTOPS = &HCB
  Public Const EM_SETPASSWORDCHAR = &HCC
  Public Const EM_EMPTYUNDOBUFFER = &HCD
  Public Const EM_GETFIRSTVISIBLELINE = &HCE
  Public Const EM_SETREADONLY = &HCF
  Public Const EM_SETWORDBREAKPROC = &HD0
  Public Const EM_GETWORDBREAKPROC = &HD1
  Public Const EM_GETPASSWORDCHAR = &HD2
  Public Const EM_SETMARGINS = &HD3
  Public Const EM_GETMARGINS = &HD4
  Public Const EM_SETLIMITTEXT = EM_LIMITTEXT  'win40 Name change
  Public Const EM_GETLIMITTEXT = &HD5
  Public Const EM_POSFROMCHAR = &HD6
  Public Const EM_CHARFROMPOS = &HD7
  Public Const EM_SETIMESTATUS = &HD8
  Public Const EM_GETIMESTATUS = &HD9
  Public Const EM_HIDESELECTION As Long = (WM_USER + 63)
  Public Const WM_MOUSEMOVE = &H200
  Public Const WM_NCMOUSEMOVE = &HA0
  
  Public Const WM_LBUTTONDOWN = &H201
  Public Const WM_LBUTTONUP = &H202
  Public Const WM_LBUTTONDBLCLK = &H203
  Public Const WM_RBUTTONDOWN = &H204
  Public Const WM_RBUTTONUP = &H205
  Public Const WM_RBUTTONDBLCLK = &H206
  Public Const WM_MBUTTONDOWN = &H207
  Public Const WM_MBUTTONUP = &H208
  Public Const WM_MBUTTONDBLCLK = &H209
  Public Const WM_MOUSEWHEEL = &H20A
  Public Const WM_NCLBUTTONDOWN = &HA1
  Public Const WM_NCLBUTTONUP = &HA2
  Public Const WM_NCLBUTTONDBLCLK = &HA3
  Public Const WM_NCRBUTTONDOWN = &HA4
  Public Const WM_NCRBUTTONUP = &HA5
  Public Const WM_NCRBUTTONDBLCLK = &HA6
  Public Const WM_NCMBUTTONDOWN = &HA7
  Public Const WM_NCMBUTTONUP = &HA8
  Public Const WM_NCMBUTTONDBLCLK = &HA9
  Public Const WM_SETREDRAW = &HB
  Public Const WM_HSCROLL As Long = &H114
  Public Const WM_VSCROLL As Long = &H115
  Public Const WM_ACTIVATEAPP As Long = &H1C
  Public Const WM_ACTIVATE As Long = &H6
  Public Const WA_ACTIVE As Long = 1
  Public Const WM_KEYDOWN As Long = &H100
  Public Const WM_KEYUP As Long = &H101
  Public Const WM_CHAR As Long = &H102
  Public Const WM_SYSCHAR As Long = &H106
  Public Const WM_SETFOCUS As Long = &H7
  Public Const MK_CONTROL = &H8
  Public Const MK_LBUTTON = &H1
  Public Const MK_RBUTTON = &H2
  Public Const MK_MBUTTON = &H10
  Public Const MK_SHIFT = &H4

  Public Const WM_NOTIFY As Long = &H4E
  Public Const WM_SYSCOMMAND As Long = &H112
  Public Const SC_NEXTWINDOW As Long = &HF040
  Public Const SC_PREVWINDOW As Long = &HF050
  
  Public Const CDN_FIRST As Long = (-601)
  Public Const CDN_FILEOK As Long = (CDN_FIRST - &H5)
  Public Const CDN_FOLDERCHANGE As Long = (CDN_FIRST - &H2)
  Public Const CDN_HELP As Long = (CDN_FIRST - &H4)
  Public Const CDN_INCLUDEITEM As Long = (CDN_FIRST - &H7)
  Public Const CDN_INITDONE As Long = (CDN_FIRST - &H0)
  Public Const CDN_SELCHANGE As Long = (CDN_FIRST - &H1)
  Public Const CDN_SHAREVIOLATION As Long = (CDN_FIRST - &H3)
  Public Const CDN_TYPECHANGE As Long = (CDN_FIRST - &H6)

  
  Public Const LB_GETITEMHEIGHT = &H1A1
  Public Const SB_LINELEFT As Long = 0
  Public Const SB_LINERIGHT As Long = 1
  Public Const SB_LINEUP As Long = 0
  Public Const SB_LINEDOWN As Long = 1
  Public Const SB_PAGEUP = &H2
  Public Const GWL_WNDPROC = (-4)
  Public Const EM_GETOPTIONS = (&H400& + 78&)
  Public Const EM_SETOPTIONS = (&H400& + 77&)
  Public Const EM_GETUNDONAME = (&H400& + 86&)
  Public Const WM_UNDO = &H304
  Public Const DIB_RGB_COLORS = 0
  Public Const DIB_PAL_COLORS = 1
  Public Const BI_RGB = 0&
  Public Const BITSPIXEL = 12
  Public Const PLANES = 14
  Public Const SRCCOPY = &HCC0020
  Public Const MERGECOPY = &HC000CA
  Public Const MERGEPAINT = &HBB0226
  Public Const SRCPAINT = &HEE0086
  Public Const PATPAINT = &HFB0A09
  Public Const PATINVERT = &H5A0049
  Public Const PATCOPY = &HF00021
  Public Const SRCAND = &H8800C6
  Public Const SRCINVERT = &H660046
  Public Const WHITENESS = &HFF0062
  Public Const SRCERASE = &H440328
  Public Const NOTSRCCOPY = &H330008
  Public Const NOTSRCERASE = &H1100A6
  Public Const TRANSCOPY = &HB8074A
  Public Const FLOODFILLBORDER = 0
  Public Const FLOODFILLSURFACE = 1
  Public Const HALFTONE As Long = 4
  Public Const COLORONCOLOR = 3

  'directory browser constants
  Public Const MAX_PATH = 260
  Public Const BFFM_INITIALIZED = 1
  Public Const BFFM_SELCHANGED = 2
  Public Const BFFM_VALIDATEFAILEDA = 3
  Public Const BFFM_VALIDATEFAILEDW = 4
  Public Const BFFM_IUNKNOWN = 5
  Public Const BFFM_SETSTATUSTEXT = (WM_USER + 100)
  Public Const BFFM_ENABLEOK = (WM_USER + 101)
  Public Const BFFM_SETSELECTION = (WM_USER + 102)
  Public Const BIF_RETURNONLYFSDIRS = 1
  Public Const BIF_DONTGOBELOWDOMAIN = 2
  Public Const BIF_STATUSTEXT = 4
  Public Const BIF_USENEWUI = 64
  
  Public Const SWP_NOACTIVATE As Long = &H10
  Public Const SWP_NOMOVE As Long = &H2
  Public Const SWP_NOOWNERZORDER As Long = &H200
  Public Const SWP_NOSIZE As Long = &H1
  Public Const HWND_TOPMOST As Long = -1
  Public Const HWND_TOP As Long = 0
  Public Const HWND_NOTOPMOST As Long = -2

  
  Public Const ALTERNATE = 1
  
  'printer capabilities
  Public Const PHYSICALHEIGHT As Long = 111
  Public Const PHYSICALOFFSETX As Long = 112
  Public Const PHYSICALOFFSETY As Long = 113
  Public Const PHYSICALWIDTH As Long = 110
  Public Const RASTERCAPS As Long = 38
  Public Const RC_BANDING As Long = 2
  Public Const RC_BITBLT As Long = 1
  Public Const RC_BITMAP64 As Long = 8
  Public Const RC_DI_BITMAP As Long = &H80
  Public Const RC_DIBTODEV As Long = &H200
  Public Const RC_FLOODFILL As Long = &H1000
  Public Const RC_GDI20_OUTPUT As Long = &H10
  Public Const RC_PALETTE As Long = &H100
  Public Const RC_SCALING As Long = 4
  Public Const RC_STRETCHBLT As Long = &H800
  Public Const RC_STRETCHDIB As Long = &H2000
  Public Const LOGPIXELSX As Long = 88
  Public Const LOGPIXELSY As Long = 90
  Public Const STANDARD_RIGHTS_REQUIRED As Long = &HF0000
  Public Const PRINTER_ACCESS_ADMINISTER As Long = &H4
  Public Const PRINTER_ACCESS_USE As Long = &H8
  Public Const PRINTER_ALL_ACCESS As Long = (STANDARD_RIGHTS_REQUIRED Or PRINTER_ACCESS_ADMINISTER Or PRINTER_ACCESS_USE)
  Public Const DM_PROMPT As Long = 4
  Public Const DM_IN_PROMPT As Long = DM_PROMPT
    
  'open/save dialog constants
  Public Const OFN_ALLOWMULTISELECT As Long = &H200
  Public Const OFN_CREATEPROMPT As Long = &H2000
  Public Const OFN_EXPLORER As Long = &H80000
  Public Const OFN_EXTENSIONDIFFERENT As Long = &H400
  Public Const OFN_FILEMUSTEXIST As Long = &H1000
  Public Const OFN_HIDEREADONLY As Long = &H4
  Public Const OFN_LONGNAMES As Long = &H200000
  Public Const OFN_NOCHANGEDIR As Long = &H8
  Public Const OFN_NODEREFERENCELINKS As Long = &H100000
  Public Const OFN_NOLONGNAMES As Long = &H40000
  Public Const OFN_NOREADONLYRETURN As Long = &H8000
  Public Const OFN_NOVALIDATE As Long = &H100
  Public Const OFN_OVERWRITEPROMPT As Long = &H2
  Public Const OFN_PATHMUSTEXIST As Long = &H800
  Public Const OFN_READONLY As Long = &H1
  Public Const OFN_SHAREAWARE As Long = &H4000
  Public Const OFN_SHOWHELP As Long = &H10
  Public Const OFN_USEMONIKERS As Long = &H1000000
  Public Const OFN_DONTADDTORECENT As Long = &H2000000
  Public Const OFN_ENABLEINCLUDENOTIFY As Long = &H400000
  Public Const OFN_ENABLESIZING As Long = &H800000
  Public Const OFN_ENABLETEMPLATE As Long = &H40
  Public Const OFN_ENABLETEMPLATEHANDLE As Long = &H80
  Public Const OFN_FORCESHOWHIDDEN As Long = &H10000000
  Public Const OFN_NONETWORKBUTTON As Long = &H20000
  Public Const OFN_NOTESTFILECREATE As Long = &H10000
  Public Const OFN_ENABLEHOOK As Long = &H20
  Public Const OFN_EX_NOPLACESBAR As Long = &H1
  Public Const OFN_SHAREFALLTHROUGH As Long = 2
  Public Const OFN_SHARENOWARN As Long = 1
  Public Const OFN_SHAREWARN As Long = 0
  Public Const FNERR_BUFFERTOOSMALL As Long = &H3003
  Public Const FNERR_FILENAMECODES As Long = &H3000
  Public Const FNERR_INVALIDFILENAME As Long = &H3002
  Public Const FNERR_SUBCLASSFAILURE As Long = &H3001
  Public Const CDERR_DIALOGFAILURE As Long = &HFFFF
  Public Const CDERR_FINDRESFAILURE As Long = &H6
  Public Const CDERR_GENERALCODES As Long = &H0
  Public Const CDERR_INITIALIZATION As Long = &H2
  Public Const CDERR_LOADRESFAILURE As Long = &H7
  Public Const CDERR_LOADSTRFAILURE As Long = &H5
  Public Const CDERR_LOCKRESFAILURE As Long = &H8
  Public Const CDERR_MEMALLOCFAILURE As Long = &H9
  Public Const CDERR_MEMLOCKFAILURE As Long = &HA
  Public Const CDERR_NOHINSTANCE As Long = &H4
  Public Const CDERR_NOHOOK As Long = &HB
  Public Const CDERR_NOTEMPLATE As Long = &H3
  Public Const CDERR_REGISTERMSGFAIL As Long = &HC
  Public Const CDERR_STRUCTSIZE As Long = &H1
  
  Public Const CDM_FIRST As Long = (WM_USER + 100)
  Public Const CDM_GETSPEC As Long = (CDM_FIRST + &H0)
  Public Const CDM_SETCONTROLTEXT As Long = (CDM_FIRST + &H4)
  Public Const CDM_SETDEFEXT As Long = (CDM_FIRST + &H6)
  Public Const edt1 As Long = &H480
  Public Const SW_SHOWNORMAL As Long = 1
  Public Const VK_RETURN As Long = &HD
  
  Public Const VER_PLATFORM_WIN32_NT As Long = 2
  Public Const VER_PLATFORM_WIN32_WINDOWS As Long = 1
  Public Const VER_PLATFORM_WIN32s As Long = 0

  'directory browser types
  Public Type BrowseInfo
    hWndOwner      As Long
    pIDLRoot       As Long
    pszDisplayName As String
    lpszTitle      As String
    ulFlags        As Long
    lpfnCallback   As Long
    lParam         As Long
    iImage         As Long
  End Type

  'types used in building bitmaps
  Public Type BITMAPINFOHEADER  '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
  End Type
  
  Public Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
  End Type
  
  Public Type BitmapInfo
    bmiHeader As BITMAPINFOHEADER
    bmiColor(16) As RGBQUAD
  End Type
  
  Public Type POINTAPI
    x As Long
    y As Long
  End Type
  
  Public Type MIDIHDR
    lpData As String
    dwBufferLength As Long
    dwBytesRecorded As Long
    dwUser As Long
    dwFlags As Long
    lpNext As Long
    Reserved As Long
  End Type
  
  Public Type vbRECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type

  Type CHARRANGE
    cpMin As Long
    cpMax As Long
  End Type
  
  Public Type vbFORMATRANGE
    hdc As Long
    hdcTarget As Long
    rc As vbRECT
    rcPage As vbRECT
    chrg As CHARRANGE
  End Type
  
  Public Type DOCINFO
    cbSize As Long
    lpszDocName As String
    lpszOutput As String
    lpszDatatype As String
    fwType As Long
  End Type
  
  Public Type NMHDR
    hwndFrom As Long
    idFrom As Long
    code As Long
    ptrOFN As Long
  End Type
  
  Public Type OPENFILENAME
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
    pvReserved As Long
    dwReserved As Long
    FlagsEx As Long
  End Type
  
  Public Type OFNOTIFY
    hdr As NMHDR
    lpOFN As OPENFILENAME
    pszFile As String ' May be NULL
  End Type
  
  Public Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128 ' Maintenance string for PSS usage
  End Type
  
  
  'api declarations
  Public Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
  Public Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
  Private Declare Function SHGetMalloc Lib "shell32" (lpMalloc As ITMalloc) As Long
' This function is used to free the memory allocated by the SHGetSpecialFolderLocation
' and the SHGetPathFromIDList functions. This function requires a pointer to the
' Free method of the IMalloc operating system object. To expose this method to
' Visual Basic, you need a reference to the ITMalloc.tlb type library enclosed with this
' sample project.

  Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
  Public Declare Function SetWindowPos Lib "user32.dll" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
  Public Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
  Public Declare Function GetCurrentDirectory Lib "kernel32" Alias "GetCurrentDirectoryA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
  Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Public Declare Function SendMessageAny Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
  Public Declare Function SendMessagePtW Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, wParam As POINTAPI, ByVal lParam As Long) As Long
  Public Declare Function SendMessagePtL Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As POINTAPI) As Long
  Public Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
  Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
  Public Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
  Public Declare Function GetTickCount Lib "kernel32" () As Long
  Public Declare Function SetClipboardData Lib "user32" Alias "SetClipboardDataA" (ByVal wFormat As Long, ByVal hMem As Long) As Long
  Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
  Public Declare Function ExtFloodFill Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long, ByVal wFillType As Long) As Long
  Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
  Public Declare Function SetStretchBltMode Lib "gdi32.dll" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long
  Public Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
  Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
  Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
  Public Declare Function SetFocusAPI Lib "user32.dll" Alias "SetFocus" (ByVal hWnd As Long) As Long
  
  Public Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
  Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
  Public Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
  Public Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
  Public Declare Function SetCapture Lib "user32" (ByVal hWnd As Long) As Long
  Public Declare Function GetCapture Lib "user32" () As Long
  Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
  Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  Public Declare Function CreateDIBSection Lib "gdi32" (ByVal hdc As Long, pBitmapInfo As BitmapInfo, ByVal un As Long, lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
  Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
  Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
       Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
  Public Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
  Public Declare Function BringWindowToTop Lib "user32" (ByVal hWnd As Long) As Long
  Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
  Public Declare Function ReleaseCapture Lib "user32" () As Long
  Public Declare Function GetBitmapDimensionEx Lib "gdi32" (ByVal hBitmap As Long, lpDimension As POINTAPI) As Long
  Public Declare Function midiOutClose Lib "winmm.dll" (ByVal hMidiOut As Long) As Long
  Public Declare Function midiOutLongMsg Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As MIDIHDR, ByVal uSize As Long) As Long
  Public Declare Function midiOutOpen Lib "winmm.dll" (lphMidiOut As Long, ByVal uDeviceID As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
  Public Declare Function midiOutPrepareHeader Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As MIDIHDR, ByVal uSize As Long) As Long
  Public Declare Function midiOutReset Lib "winmm.dll" (ByVal hMidiOut As Long) As Long
  Public Declare Function midiOutShortMsg Lib "winmm.dll" (ByVal hMidiOut As Long, ByVal dwMsg As Long) As Long
  Public Declare Function midiOutUnprepareHeader Lib "winmm.dll" (ByVal hMidiOut As Long, lpMidiOutHdr As MIDIHDR, ByVal uSize As Long) As Long
  Public Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long

  Public Declare Function BeginPath Lib "gdi32" (ByVal hdc As Long) As Long
  Public Declare Function EndPath Lib "gdi32" (ByVal hdc As Long) As Long
  Public Declare Function WidenPath Lib "gdi32" (ByVal hdc As Long) As Long
  Public Declare Function PathToRegion Lib "gdi32" (ByVal hdc As Long) As Long
  
  Public Declare Function FillRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long, ByVal hBrush As Long) As Long
  Public Declare Function PaintRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long) As Long
  Public Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
  Public Declare Function FrameRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long, ByVal hBrush As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
  Public Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
  Public Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
  Public Declare Function PtInRegion Lib "gdi32" (ByVal hRgn As Long, ByVal x As Long, ByVal y As Long) As Long
  Public Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
  Public Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, lpPoint As Long) As Long
  Public Declare Function ScreenToClient Lib "user32.dll" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long


  Public Declare Function StartDoc Lib "gdi32" Alias "StartDocA" (ByVal hdc As Long, doc As DOCINFO) As Long
  Public Declare Function EndDoc Lib "gdi32" (ByVal hdc As Long) As Long
  Public Declare Function StartPage Lib "gdi32" (ByVal hdc As Long) As Long
  Public Declare Function EndPage Lib "gdi32" (ByVal hdc As Long) As Long

  Public Declare Function SaveDC Lib "gdi32" (ByVal hdc As Long) As Long
  Public Declare Function RestoreDC Lib "gdi32" (ByVal hdc As Long, ByVal SavedDC As Long) As Long

  Public Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
  Public Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long

  Public Declare Function GetParent Lib "user32.dll" (ByVal hWnd As Long) As Long
  Public Declare Function GetLastError Lib "kernel32.dll" () As Long

  Public Declare Function GetVersionEx Lib "kernel32.dll" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
  Public Declare Function HtmlHelp Lib "hhctrl.ocx" Alias "HtmlHelpA" (ByVal hwndCaller As Long, ByVal pszFile As String, ByVal uCommand As Long, ByVal dwData As Long) As Long
  Public Declare Function HtmlHelpS Lib "hhctrl.ocx" Alias "HtmlHelpA" (ByVal hwndCaller As Long, ByVal pszFile As String, ByVal uCommand As Long, ByVal dwData As String) As Long
  Public Declare Function GetDesktopWindow Lib "user32.dll" () As Long

  Public Const HH_DISPLAY_TOPIC As Long = &H0
  Public Const HH_DISPLAY_INDEX As Long = &H2
  Public Const HH_DISPLAY_SEARCH As Long = &H3
  Public Const HH_DISPLAY_TOC As Long = &H1
  Public Const HH_SET_WIN_TYPE = &H4
  Public Const HH_GET_WIN_TYPE = &H5
  Public Const HH_GET_WIN_HANDLE = &H6

' Display string resource ID or text in a popupwin.
  Public Const HH_DISPLAY_TEXT_POPUP = &HE
' Display mapped numeric value in dwdata
  Public Const HH_HELP_CONTEXT = &HF
' Text pop-up help, similar to WinHelp's HELP_CONTEXTMENU
  Public Const HH_TP_HELP_CONTEXTMENU = &H10
' Text pop-up help, similar to WinHelp's HELP_WM_HELP
  Public Const HH_TP_HELP_WM_HELP = &H11



Private Function ChangeExtension(ByRef FileName As String, Filter As String, Index As Long) As String

  'compares the extension on Filename to the extension belonging to
  'first extension for filter that numbered as Index
  '
  'if the filter extension is unique (no '*' or '?') the function returns
  'the extension (without '*.' leader)
  '
  'if they don't match, filename is modified to use the correct extension,
  '
  'if the filter is not unique, function returns empty string)
  '
  'filename is assumed to be valid;
  'filter is assumed to be pairs of description/file filters separated by
  'null character (ChrW$(0)) with an extra null character at the end
  '
  'Index is assumed valid; it is not checked for error here
  
  Dim strFileExt As String, strFilterExt As String
  Dim strExt() As String
  Dim lngPos As Long
  
  On Error GoTo ErrHandler
  
  'get extension of desired filter
  strExt = Split(Filter, ChrW$(0))
  
  strFilterExt = strExt(Index * 2 + 1)
  'filter should be in form '*.xxx'
  If Left$(strFilterExt, 2) <> "*." Then
    'no extension change required
    Exit Function
  End If
  'strip off the first two characters
  strFilterExt = Right$(strFilterExt, Len(strFilterExt) - 2)
  
  'no asterisks or question marks or periods
  If InStrB(1, strFilterExt, ChrW$(42)) <> 0 Or InStrB(1, strFilterExt, ChrW$(63)) <> 0 Or InStrB(1, strFilterExt, ChrW$(46)) <> 0 Then
    'invalid filter; no extension change required
    Exit Function
  End If
  
  'no more than three characters
  If Len(strFilterExt) > 3 Or Len(strFilterExt) < 1 Then
    'invalid filter; no extension change required
    Exit Function
  End If
  
  'strFilterExt is the extension
  ChangeExtension = strFilterExt
  
  'if no filename yet
  If LenB(FileName) = 0 Then
    'no extension change required
    Exit Function
  End If
  
  'now get extension of filename
  lngPos = InStrRev(FileName, ChrW$(46))
  
  'if not found,
  If lngPos = 0 Then
    'no extension; add filter extension and return true
    FileName = FileName & "." & strFilterExt
    Exit Function
  End If
  
  'get extension
  strFileExt = Right$(FileName, Len(FileName) - lngPos)
  
  'compare
  If StrComp(strFileExt, strFilterExt, vbTextCompare) <> 0 Then
    'extension has changed; change filename to match
    FileName = Left$(FileName, lngPos - 1) & "." & strFilterExt
  End If
Exit Function

ErrHandler:
  'ignore any errors
  Err.Clear
  ChangeExtension = vbNullString
End Function

Public Function SaveDlgHook(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

  On Error Resume Next
  
  'change of filter occurs when notify msg contains a typechange parameter
  
  Dim strFile As String, strExt As String
  Dim rtn As Long, hPCDWin As Long
  Dim ofnNotify As OFNOTIFY
  
  Select Case uMsg
  Case WM_NOTIFY
    'copy lParam to ofn structure
    CopyMemory ofnNotify, ByVal lParam, 16&
    Select Case ofnNotify.hdr.code
    Case CDN_TYPECHANGE
      'changing type
      
      'copy enough of the OFN structure to obtain the new index number
      CopyMemory ofnNotify.lpOFN, ByVal ofnNotify.hdr.ptrOFN, 28&
      
      'handle to parent dialog
      hPCDWin = GetParent(hWnd)
  
      'get current filename
      strFile = Space$(256)
      rtn = SendMessageByString(hPCDWin, CDM_GETSPEC, 256&, ByVal strFile)
      'if error
      If rtn = 0 Then
        Exit Function
      End If
      'trim off trailing null character, and any spaces
      strFile = Trim$(strFile)
      If Asc(Right$(strFile, 1)) = 0 Then
        strFile = Left$(strFile, Len(strFile) - 1)
      End If
  
      'change extension to match new filter
      'if extension does not match selected filter
      strExt = ChangeExtension(strFile, ofn.lpstrFilter, ofnNotify.lpOFN.nFilterIndex - 1)
  
      'if an extension was selected
      If LenB(strExt) <> 0 Then
        'change filename displayed in the textbox
        rtn = SendMessageByString(hPCDWin, CDM_SETCONTROLTEXT, edt1, strFile)
        
        'change default extension
        'add trailing null char
        strExt = strExt & ChrW$(0)
        rtn = SendMessageByString(hPCDWin, CDM_SETDEFEXT, 0&, strExt)
      End If
    End Select
  End Select
End Function




Public Function LEMainWndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  
  On Error Resume Next
  
  'if scrolling?
  Select Case uMsg
  Case WM_HSCROLL
    LayoutEditor.HScroll_Click wParam And &HFFFF&
    
  Case WM_VSCROLL
    LayoutEditor.VScroll_Click wParam And &HFFFF&
    
  End Select
  
  'pass along
  LEMainWndProc = CallWindowProc(PrevLEWndProc, hWnd, uMsg, wParam, lParam)
  
End Function
Public Function ScrollWndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  
  Dim cliPT As POINTAPI
  
  On Error Resume Next
  
  Dim frm As Form, lngPrevWndProc As Long
  
  'find the correct window
  For Each frm In Forms
    If frm.Name = "frmGlobals" Then
      If frm.fgGlobals.hWnd = hWnd Then
        lngPrevWndProc = frm.PrevFGWndProc
        
        
        Exit For
      End If
    End If
    If frm.Name = "frmObjectEdit" Then
      If frm.fgObjects.hWnd = hWnd Then
        lngPrevWndProc = frm.PrevFGWndProc
        Exit For
      End If
    End If
  Next
  
  If lngPrevWndProc = 0 Then
    Debug.Print "unknown window??"
    Exit Function
  End If
  
  'need to trap wheel events
  Select Case uMsg
  Case WM_MOUSEWHEEL
    'convert x and y
    cliPT.x = lParam And &HFFFF&
    cliPT.y = lParam / &H10000
    ScreenToClient hWnd, cliPT
    
    frm.MouseWheel wParam And &HFFFF&, wParam / &H10000, cliPT.x, cliPT.y
  Case Else
    'pass along
    ScrollWndProc = CallWindowProc(lngPrevWndProc, hWnd, uMsg, wParam, lParam)
  End Select
End Function

Public Function LBWndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  
  On Error Resume Next
  
  Dim frm As Form, lngPrevWndProc As Long
  
  'find the correct window
  For Each frm In Forms
    If frm.Name = "frmWordsEdit" Then
      If frm.lstWords.hWnd = hWnd Then
        lngPrevWndProc = frm.PrevLBWndProc
        Exit For
      End If
    End If
    If frm.Name = "frmPictureEdit" Then
      If frm.lstCommands.hWnd = hWnd Then
        lngPrevWndProc = frm.PrevLBWndProc
        Exit For
      End If
    End If
  Next
  
  If lngPrevWndProc = 0 Then
    Debug.Print "unknown window??"
    Exit Function
  End If
  
  Select Case uMsg
  Case WM_CHAR
    'ignore char characters
    'this prevents Ctrl+key combination
    'from automatically scrolling the
    'list box
    Exit Function
  Case WM_LBUTTONDOWN, WM_LBUTTONUP
    'if control is pressed
    If (wParam And &H8) Then
      Exit Function
    End If
  Case Else
  End Select
  
  'pass along
  LBWndProc = CallWindowProc(lngPrevWndProc, hWnd, uMsg, wParam, lParam)
End Function

Public Function TbarWndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
  
  Dim i As Long
  Dim tmpX As Long, tmpY As Long
  
  On Error Resume Next
  
  'if user is clicking on a button
  If uMsg = &H210 And (wParam And &HFFFF&) = WM_LBUTTONDOWN Then
    tmpX = lParam And &HFFFF&
    tmpY = lParam \ &H10000
    
    'determine if a drawing tool button is being clicked
    For i = 2 To 6
      With LayoutEditor.Toolbar1.Buttons(i)
        If tmpX >= .Left And tmpX <= .Left + .Width And tmpY >= .Top And tmpY <= .Top + .Height Then
          'this is the button
          LayoutEditor.TBClicked i
          Exit For
        End If
      End With
    Next i
  End If
  
  'pass along all messages
  TbarWndProc = CallWindowProc(PrevTbarWndProc, hWnd, uMsg, wParam, lParam)
End Function

Public Function ByValAddressOf(ByRef AddressOfIn As Long)
  'a workaround function to allow
  'the value of AddressOf to be assigned to a variable
  'VB doesn't allow it to be done directly
  

  ByValAddressOf = AddressOfIn
End Function


Public Function BrowseCallbackProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

  Dim rtn As Long
  Dim lpDir As Long
  Dim shCurDir As String
  
  Select Case uMsg
  Case BFFM_INITIALIZED
    'set directory by passing string pointer by value
    '(pass 1(true) for wParam)
    rtn = SendMessageByString(hWnd, BFFM_SETSELECTION, 1, BrowserStartDir)
 
 Case BFFM_SELCHANGED
    shCurDir = String$(MAX_PATH, 0)
    If (SHGetPathFromIDList(wParam, shCurDir)) Then
      shCurDir = Left$(shCurDir, InStr(shCurDir, vbNullChar) - 1)
      lpDir = lstrcat(shCurDir, vbNullString)
      rtn = SendMessage(hWnd, BFFM_SETSTATUSTEXT, 1, ByVal lpDir)
    End If
  End Select
End Function

Public Function DirFromID(Pidl As Long) As String
      
  'converts a pidl to a string
  
  Dim rtn As Long
  
  'create buffer to hold string
  DirFromID = Space$(MAX_PATH)
  'call conversion function
  rtn = SHGetPathFromIDList(Pidl, DirFromID)
  'trim the returned string
  DirFromID = Left$(DirFromID, InStr(DirFromID, vbNullChar) - 1)
End Function


Public Function GetNewDir(ByVal hWnd As Long, DialogMsg As String)

  On Error GoTo ErrHandler
  
  Dim lpIDList As Long
  Dim biNewDir As BrowseInfo
  Dim ShellMalloc As ITMalloc
  Dim rtn As Long
  
  'build browser info structure
  With biNewDir
    'handle of parent window
    .hWndOwner = hWnd
    'message that appears above treelist
    .lpszTitle = DialogMsg
    'set flags
    .ulFlags = BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN + BIF_USENEWUI + BIF_STATUSTEXT
    'set pointer to callback address
    .lpfnCallback = ByValAddressOf(AddressOf BrowseCallbackProc)
    .pszDisplayName = String$(MAX_PATH, 32)
  End With

  'show browser, get pidl
  lpIDList = SHBrowseForFolder(biNewDir)

  'if not canceled (valid pidl returned)
  If lpIDList Then
    'convert pidl to string
    GetNewDir = DirFromID(lpIDList)
    
    'the calling application is responsible for freeing this pointer.
    'You can free the pointer by using the Free method of the IMalloc
    'operating system object through the SHGetMalloc function. Visual
    'Basic can only access the free method if the method is exposed
    'through a type library. The ITMalloc.tlb type library to expose
    'the free method came from the VB sample program "SFOLDER.EXE- Gets
    'the Path of a Special Folder" (Article ID: Q191198)
    
     rtn = SHGetMalloc(ShellMalloc)
     Debug.Print "getmal? "; rtn, lpIDList
     ShellMalloc.Free lpIDList
     
     Set ShellMalloc = Nothing
  End If
Exit Function

ErrHandler:
  Debug.Print "bad thing happened: "; Err.Number, Err.Description
  Resume Next
End Function


Public Function PropWndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

  Dim cliPT As POINTAPI
  
  On Error Resume Next
  
  'need to trap wheel events
  Select Case uMsg
  Case WM_MOUSEWHEEL
    
    'convert x and y
    cliPT.x = lParam And &HFFFF&
    cliPT.y = lParam \ &H10000
    ScreenToClient hWnd, cliPT
    
    frmMDIMain.MouseWheel wParam And &HFFFF&, wParam / &H10000, cliPT.x, cliPT.y
  End Select
  
  'pass along all messages
  PropWndProc = CallWindowProc(PrevPropWndProc, hWnd, uMsg, wParam, lParam)
End Function


