VERSION 5.00
Begin VB.Form frmGetResourceNum 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Add View"
   ClientHeight    =   3240
   ClientLeft      =   30
   ClientTop       =   330
   ClientWidth     =   3000
   Icon            =   "frmGetResourceNum.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3240
   ScaleWidth      =   3000
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtDescription 
      Height          =   1230
      Left            =   3120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   8
      Top             =   945
      Width           =   3240
   End
   Begin VB.TextBox txtID 
      Height          =   285
      Left            =   3120
      TabIndex        =   7
      Top             =   360
      Visible         =   0   'False
      Width           =   3240
   End
   Begin VB.CheckBox chkIncludePic 
      Caption         =   "Create matching Picture"
      Height          =   255
      Left            =   360
      TabIndex        =   4
      Top             =   2355
      Visible         =   0   'False
      Width           =   2700
   End
   Begin VB.ListBox lstResNum 
      Height          =   1230
      Left            =   180
      TabIndex        =   3
      Top             =   1065
      Width           =   2640
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   372
      Left            =   1620
      TabIndex        =   6
      Top             =   2700
      Width           =   1116
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   372
      Left            =   210
      TabIndex        =   5
      Top             =   2700
      Width           =   1116
   End
   Begin VB.Label lblDescription 
      Caption         =   "&Description:"
      Height          =   270
      Left            =   3120
      TabIndex        =   10
      Top             =   705
      Width           =   2025
   End
   Begin VB.Label lblID 
      Caption         =   "&Resource ID:"
      Height          =   270
      Left            =   3120
      TabIndex        =   9
      Top             =   120
      Width           =   2025
   End
   Begin VB.Label lblCurrent 
      Alignment       =   2  'Center
      Caption         =   "1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   900
      TabIndex        =   1
      Top             =   315
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "Current Resource Number: "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   225
      Left            =   360
      TabIndex        =   0
      Top             =   45
      Width           =   2415
   End
   Begin VB.Label Label1 
      Caption         =   "Select a view for testing pictures:"
      Height          =   465
      Left            =   165
      TabIndex        =   2
      Top             =   825
      Width           =   2730
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "frmGetResourceNum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

  Public ResType As AGIResType
  Public NewResNum As Byte
  Public OldResNum As Byte
  Public Canceled  As Boolean
  Public WindowFunction As EGetRes
Public Sub Activate()
  'bridge method to call the form's Activate event method
  Form_Activate
End Sub

Private Sub AdjustControls()
  
  'shows/hides form controls and adjusts
  'form height and control positions based on window function
  
  'if renumbering status doesnt match
  If lblCurrent.Visible <> (WindowFunction = grRenumber) Then
    'if on (but should be off)
    If lblCurrent.Visible Then
      'hide it
      lblCurrent.Visible = False
      Label2.Visible = False
      'move rest up by one
      Label1.Top = Label1.Top - 705
      lstResNum.Top = lstResNum.Top - 705
      lstResNum.Height = lstResNum.Height + 390
      chkIncludePic.Top = chkIncludePic.Top - 315
      cmdOK.Top = cmdOK.Top - 315
      cmdCancel.Top = cmdCancel.Top - 315
      Me.Height = Me.Height - 315
    Else
      'show it
      lblCurrent.Visible = True
      Label2.Visible = True
      'move rest up by one
      Label1.Top = Label1.Top + 705
      lstResNum.Top = lstResNum.Top + 705
      lstResNum.Height = lstResNum.Height - 390
      chkIncludePic.Top = chkIncludePic.Top + 315
      cmdOK.Top = cmdOK.Top + 315
      cmdCancel.Top = cmdCancel.Top + 315
      Me.Height = Me.Height + 315
    End If
  End If
    
  'if checkbox and layout mode don't match
  If chkIncludePic.Visible <> (WindowFunction = grAddLayout Or ((WindowFunction = grAddNew Or WindowFunction = grImport) And ResType = rtLogic)) Then
    'if on (but should be off)
    If chkIncludePic.Visible Then
      'hide it
      chkIncludePic.Visible = False
      'resize listbox
      lstResNum.Height = lstResNum.Height + 120
    Else
      'show it
      chkIncludePic.Visible = True
      'resize listbox
      lstResNum.Height = lstResNum.Height - 120
    End If
  End If
  
  'if ID box and layout mode don't match
  If txtID.Visible <> (WindowFunction = grAddLayout Or WindowFunction = grAddNew) Then
    'if on but should be off
    If txtID.Visible Then
      'hide it
      txtID.Visible = False
      Me.Width = Me.Width - 3555
    Else
      'show it
      txtID.Visible = True
      Me.Width = Me.Width + 3555
    End If
  End If
  
  Select Case WindowFunction
  Case grAddNew
    Label1.Caption = "Select a number for this new " & ResTypeName(ResType) & ":"
    Me.Caption = "Add New " & ResTypeName(ResType)
  
  Case grImport
    Label1.Caption = "Select a number for this imported " & ResTypeName(ResType) & ":"
    Me.Caption = "Import " & ResTypeName(ResType)
    Me.cmdCancel.Caption = "Don't Import"
    
  Case grRenumber
    Label1.Caption = "Select a new number for this " & ResTypeName(ResType) & ":"
    Select Case ResType
    Case rtLogic
      Caption = ResourceName(Logics(OldResNum), True, True)
    Case rtPicture
      Caption = ResourceName(Pictures(OldResNum), True, True)
    Case rtSound
      Caption = ResourceName(Sounds(OldResNum), True, True)
    Case rtView
      Caption = ResourceName(Views(OldResNum), True, True)
    End Select
    lblCurrent.Caption = CStr(OldResNum)
      
  Case grOpen
    Label1.Caption = "Select the " & ResTypeName(ResType) & " to open:"
    Me.Caption = "Open " & ResTypeName(ResType)
  
  Case grTestView
    Label1.Caption = "Select a view for testing pictures:"
    Me.Caption = "Select Test View"
  
  Case grAddLayout
    Label1.Caption = "Select a number for this new room:"
    Me.Caption = "Add New Room"
    
  Case grShowRoom
    Label1.Caption = "Select a room to show:"
    Me.Caption = "Show Room"
    
  Case grMenu
    Label1.Caption = "Select the logic with the game's menu:"
    Caption = "Extract Menu"
    
  End Select
  

  

End Sub

Public Sub FormSetup()

  Dim i As Long, lngOldNum As Long, strID As String
  Dim tmpView As AGIView, tmpLogic As AGILogic
  Dim tmpSound As AGISound, tmpPicture As AGIPicture
  Dim tmpCol As Collection
  
  On Error GoTo ErrHandler
  
  'rebuild list of available resource numbers
  
  'store current selection
  If lstResNum.ListIndex <> -1 Then
    lngOldNum = CLng(Val(lstResNum.Text))
  Else
    lngOldNum = -1
  End If
  strID = txtID.Text
  
  'clear the listbox
  lstResNum.Clear
  
  Select Case WindowFunction
  Case grAddNew, grRenumber, grAddLayout, grImport
    'add all numbers to temporary collection
    Set tmpCol = New Collection
    For i = 0 To 255
      tmpCol.Add CStr(i), CStr(i)
    Next i
  
    'remove all resource numbers that are in use
    Select Case ResType
    Case rtView
      'if any views,
      If Views.Count > 0 Then
        For Each tmpView In Views
          tmpCol.Remove CStr(tmpView.Number)
        Next
      End If
    Case rtPicture
      'if any pictures,
      If Pictures.Count > 0 Then
        For Each tmpPicture In Pictures
          tmpCol.Remove CStr(tmpPicture.Number)
        Next
      End If
    Case rtSound
      'if any sounds,
      If Sounds.Count > 0 Then
        For Each tmpSound In Sounds
          tmpCol.Remove CStr(tmpSound.Number)
        Next
      End If
    Case rtLogic
      'remove all logics that are in use
      If Logics.Count > 0 Then
        For Each tmpLogic In Logics
          tmpCol.Remove CStr(tmpLogic.Number)
        Next
      End If
      
      'if adding rooms in logic/picture pairs
      If Me.chkIncludePic.Value = vbChecked Then
        'ensure logic 0 is removed
        On Error Resume Next
        tmpCol.Remove CStr(0)
        Err.Clear
      
        'if any objects,
        If Pictures.Count > 0 Then
          'in many cases, the corresponding number
          'will already be removed because it was
          'in use as a logic number; in this case
          'the remove method will generate an error,
          'so use Resume Next to just ignore and
          'go on to next picture
          On Error Resume Next
          
          For Each tmpPicture In Pictures
            'remove
            tmpCol.Remove CStr(tmpPicture.Number)
          Next
        End If
      End If
      
      'if adding to layout room 0 is NEVER available
      If WindowFunction = grAddLayout Then
        'ensure logic 0 is removed
        On Error Resume Next
        tmpCol.Remove CStr(0)
        Err.Clear
      End If
    End Select
    
    'add remaining numbers to the combobox
    For i = 1 To tmpCol.Count
      lstResNum.AddItem tmpCol(i)
      lstResNum.ItemData(i - 1) = tmpCol(i)
    Next i
    
  Case grOpen, grTestView, grMenu
    'to ensure resources are sorted by number, use the tmpcollection
    Set tmpCol = New Collection
    For i = 0 To 255
      tmpCol.Add CStr(i), CStr(i)
    Next i
    
    On Error Resume Next
    'add available items
    Select Case ResType
    Case rtView
      For Each tmpView In Views
        'remove
        tmpCol.Remove CStr(tmpView.Number)
      Next
      'step through collection again to add numbers to list
      For i = 0 To 255
        'attempt to access this resource in the temp collection
        If tmpCol(CStr(i)) Then
        End If
        'if it has been removed (means the number is valid)
        'an error is raised
        If Err.Number <> 0 Then
          Err.Clear
          If Settings.ShowResNum Then
            lstResNum.AddItem ResourceName(Views(i), True)
          Else
            lstResNum.AddItem CStr(i) & " - " & Views(i).ID
          End If
          lstResNum.ItemData(lstResNum.ListCount - 1) = i
          Debug.Assert Err.Number = 0
        End If
      Next i
  
    Case rtPicture
      For Each tmpPicture In Pictures
        'remove
        tmpCol.Remove CStr(tmpPicture.Number)
      Next
      'step through collection again to add numbers to list
      For i = 0 To 255
        'attempt to access this resource in the temp collection
        If tmpCol(CStr(i)) Then
        End If
        'if it has been removed (means the number is valid)
        'an error is raised
        If Err.Number <> 0 Then
          Err.Clear
          If Settings.ShowResNum Then
            lstResNum.AddItem ResourceName(Pictures(i), True)
          Else
            lstResNum.AddItem CStr(i) & " - " & Pictures(i).ID
          End If
          Debug.Assert Err.Number = 0
          lstResNum.ItemData(lstResNum.ListCount - 1) = i
        End If
      Next i
  
    Case rtSound
      For Each tmpSound In Sounds
        'remove
        tmpCol.Remove CStr(tmpSound.Number)
      Next
      'step through collection again to add numbers to list
      For i = 0 To 255
        'attempt to access this resource in the temp collection
        If tmpCol(CStr(i)) Then
        End If
        'if it has been removed (means the number is valid)
        'an error is raised
        If Err.Number <> 0 Then
          Err.Clear
          If Settings.ShowResNum Then
            lstResNum.AddItem ResourceName(Sounds(i), True)
          Else
            lstResNum.AddItem CStr(i) & " - " & Sounds(i).ID
          End If
          Debug.Assert Err.Number = 0
          lstResNum.ItemData(lstResNum.ListCount - 1) = i
        End If
      Next i
  
    Case rtLogic
      For Each tmpLogic In Logics
        'remove
        tmpCol.Remove CStr(tmpLogic.Number)
      Next
      'step through collection again to add numbers to list
      For i = 0 To 255
        'attempt to access this resource in the temp collection
        If tmpCol(CStr(i)) Then
        End If
        'if it has been removed (means the number is valid)
        'an error is raised
        If Err.Number <> 0 Then
          Err.Clear
          If Settings.ShowResNum Then
            lstResNum.AddItem ResourceName(Logics(i), True)
          Else
            lstResNum.AddItem CStr(i) & " - " & Logics(i).ID
          End If
          Debug.Assert Err.Number = 0
          lstResNum.ItemData(lstResNum.ListCount - 1) = i
        End If
      Next i
    End Select
  
  Case grAddLayout
  
  Case grShowRoom
    'add all numbers to temporary collection
    Set tmpCol = New Collection
    For i = 0 To 255
      tmpCol.Add CStr(i), CStr(i)
    Next i
  
    'remove all logics that are currently NOT a room
    For Each tmpLogic In Logics
      'skip logic 0
      If tmpLogic.Number <> 0 Then
        If Not tmpLogic.IsRoom Then
          'remove
          tmpCol.Remove CStr(tmpLogic.Number)
        End If
      End If
    Next
    
    On Error Resume Next
    'step through collection again to add numbers to list
    For i = 0 To 255
      'attempt to access this resource in the temp collection
      If tmpCol(CStr(i)) Then
      End If
      'if it has been removed (means the number is valid)
      'an error is raised
      If Err.Number <> 0 Then
        Err.Clear
        If Settings.ShowResNum Then
          lstResNum.AddItem ResourceName(Logics(i), True)
        Else
          lstResNum.AddItem CStr(i) & " - " & Logics(i).ID
        End If
        lstResNum.ItemData(lstResNum.ListCount - 1) = i
        Debug.Assert Err.Number = 0
      End If
    Next
    
    'if no rooms added
    If lstResNum.ListCount = 0 Then
      MsgBox "All logics in the game are currently visible.", vbInformation + vbOKOnly, "Show Room"
      'set cancel to true
      Canceled = True
      'hide form and exit
      Hide
      Exit Sub
    End If
      
  End Select
  
  'set form size and controls
  AdjustControls
  
  'if a number was previously selected,
  If lngOldNum <> -1 Then
    'search for old number
    For i = 0 To lstResNum.ListCount - 1
      If lstResNum.List(i) = lngOldNum Then
        lstResNum.ListIndex = i
        txtID.Text = strID
        Exit For
      End If
    Next i
    'if no match found, default to first item
    If i = lstResNum.ListCount Then
      lstResNum.ListIndex = 0
    End If
  Else
    'default to first item
    lstResNum.ListIndex = 0
  End If
  
  'assume cancel
  Canceled = True
Exit Sub

ErrHandler:
  Debug.Assert False
  Resume Next
End Sub

Private Sub chkIncludePic_Click()

  'use form setup to adjust form to match
  'new state of pic feature
  FormSetup
End Sub

Private Sub cmdCancel_Click()

  Me.Hide
  'user canceled
  Canceled = True
End Sub

Private Sub cmdOK_Click()
  
  Dim tmpRes As Object
  
  'get resnum
  NewResNum = CByte(lstResNum.ItemData(lstResNum.ListIndex))
  
  'if renumbering AND number hasn't changed,
  If (WindowFunction = grRenumber) And (OldResNum = NewResNum) Then
    'same as canceling
    Canceled = True
  ElseIf WindowFunction = grAddNew Then
    'validate the resource ID
    Select Case ResType
    Case rtLogic
      For Each tmpRes In Logics
        If tmpRes.ID = txtID.Text Then
          MsgBox txtID.Text & " is already assigned. Choose a different ID.", vbInformation + vbOKOnly, "Duplicate Resource ID"
          Exit Sub
        End If
      Next
    Case rtPicture
      For Each tmpRes In Pictures
        If tmpRes.ID = txtID.Text Then
          MsgBox txtID.Text & " is already assigned. Choose a different ID.", vbInformation + vbOKOnly, "Duplicate Resource ID"
          Exit Sub
        End If
      Next
    Case rtSound
      For Each tmpRes In Sounds
        If tmpRes.ID = txtID.Text Then
          MsgBox txtID.Text & " is already assigned. Choose a different ID.", vbInformation + vbOKOnly, "Duplicate Resource ID"
          Exit Sub
        End If
      Next
    Case rtView
      For Each tmpRes In Views
        If tmpRes.ID = txtID.Text Then
          MsgBox txtID.Text & " is already assigned. Choose a different ID.", vbInformation + vbOKOnly, "Duplicate Resource ID"
          Exit Sub
        End If
      Next
    End Select
    'id is ok
    Canceled = False
  Else
    'user did not cancel
    Canceled = False
  End If
  
  Me.Hide
End Sub

Private Sub Form_Activate()

  'setup the form
  FormSetup
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

  'check for help key
  If Shift = 0 And KeyCode = vbKeyF1 Then
    HtmlHelpS HelpParent, WinAGIHelp, HH_DISPLAY_TOPIC, "htm\winagi\Managing Resources.htm#resnum"
    KeyCode = 0
  End If
End Sub


Private Sub lstResNum_Click()
  
  'enable ok button
  cmdOK.Enabled = True
  
  'if adding or importing a new resource
  If (WindowFunction = grAddLayout Or WindowFunction = grAddNew Or WindowFunction = grImport) Then
    'if format is restype and resnum OR is blank
    If LenB(txtID.Text) = 0 Or (Left$(txtID.Text, Len(ResTypeName(ResType))) = ResTypeName(ResType)) Then
      'update id box
      txtID.Text = ResTypeName(ResType) & lstResNum.Text
    End If
  End If
End Sub

Private Sub lstResNum_DblClick()
  'same as clicking OK
  cmdOK_Click
  
End Sub

Private Sub txtID_Change()

  'enable ok only if id is Not null
  cmdOK.Enabled = LenB(txtID.Text) <> 0
End Sub


